various changes around data volumes
[distro-setup] / btrbk-run
index c59faf99c9eecb0e976a532bd6e2ef00225c59f7..8cae3a79cb744f85edbd662fc192e7f6afdcaa85 100755 (executable)
--- a/btrbk-run
+++ b/btrbk-run
@@ -4,14 +4,13 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
-
 usage() {
     echo "top of script file:"
     sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
     exit $1
 }
 
-script_dir=$(dirname $(readlink "$BASH_SOURCE"))
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 
 # todo: finish figuring out fai / distro-setup
 # initial fstab / subvol setup.
@@ -37,62 +36,36 @@ read primary <<<"$@"
 
 ##### end command line parsing ########
 
-target-section() {
-    local root=$1
-    local subvol=$2
-    mountpoint $root &>/dev/null || return
-    cat >>/etc/btrbk.conf <<EOF
-volume $root
-subvolume $subvol
-$remote_target
-
-EOF
-}
-
 rsync-dirs() {
     local host=$1
     local path=$2
     rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
 }
 
+vol-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+volume $vol
+EOF
+}
+sub-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+subvolume $sub
+EOF
+}
+tg-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+target send-receive ssh://$tg$vol/btrbk
+EOF
+}
 
-# note q is owned by root:1000
-# note p is owned 1000:1000 and chmod 700
-mountpoints=(/q)
-if awk '{print $2}' /etc/fstab | grep -xF /p &>/dev/null; then
-    mountpoints+=(/p)
-fi
 
-# if our mountpoints are from stale snapshots,
-# it doesn't make sense to do a backup.
-check-subvol-stale ${mountpoints[@]} || exit 1
 
-if [[ ! $targets ]]; then
-    case $HOSTNAME in
-        tp|x2)
-            if ! timeout -s 9 10 ssh frodo :; then
-                targets=($HOME_DOMAIN)
-            fi
-            ;;
-    esac
-    targets=(frodo)
+if ! which btrbk &>/dev/null; then
+    echo "$0: error: no btrbk binary found"
 fi
 
-
-# todo: make bash shell prompt show something when
-# a subvol on current host is not fresh.
-# umount first to ensure we don't have any errors
-# todo: do some kill fuser stuff to make umount more reliable
-# todo: run this on a systemd timer on $primary, once per hour,
-# and if primary is, change that timer over to primary, and make
-# sure we mount the latest
-# todo: setup lock so that if this is already running, we exit out, so
-# that manual runs don't interfere with cronjobs.
-
-for tg in ${targets[@]}; do
-    cat >/etc/btrbk.conf <<'EOF'
+cat >/etc/btrbk.conf <<'EOF'
 ssh_identity /root/.ssh/id_rsa
-transaction_syslog daemon
 
 # so we only run one at a time
 lockfile                   /var/lock/btrbk.lock
@@ -118,16 +91,71 @@ target_preserve_min 6h
 # btrbk -l debug -v dryrun
 EOF
 
-    remote_target="target send-receive ssh://${tg}/mnt/root/btrbk"
+# note q is owned by root:1000
+# note p is owned 1000:1000 and chmod 700
+mountpoints=(/q)
+if awk '{print $2}' /etc/fstab | grep -xF /p &>/dev/null; then
+    mountpoints+=(/p)
+fi
+
+# if our mountpoints are from stale snapshots,
+# it doesn't make sense to do a backup.
+check-subvol-stale ${mountpoints[@]} || exit 1
+
+if [[ ! $targets ]]; then
+    case $HOSTNAME in
+        tp|x2)
+            if ! timeout -s 9 10 ssh frodo :; then
+                targets=($HOME_DOMAIN)
+            fi
+            ;;
+    esac
+    targets=(frodo)
+fi
 
+
+# for i, we just do a 1 way sync from master to backup,
+# and manually manage any changes to that.
+do_i=false
+for tg in ${targets[@]}; do
+    # for an initial run, btrbk requires the dir to exist
+    ssh root@$tg mkdir -p /mnt/root/btrbk
     if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-        target-section /mnt/iroot i
+        do_i=true
     fi
-    for d in ${mountpoints[@]}; do
-        target-section /mnt/root ${d##*/}
+done
+
+
+vol=/mnt/root
+vol-conf
+for m in ${mountpoints[@]}; do
+    sub=${m##*/}
+    sub-conf
+    for tg in ${targets[@]}; do
+        tg-conf
     done
 done
 
+if $do_i; then
+    vol=/mnt/iroot
+    vol-conf
+    sub=i
+    sub-conf
+    tg=frodo
+    vol=/mnt/root
+    tg-conf
+fi
+
+
+
+# todo: umount first to ensure we don't have any errors
+# todo: do some kill fuser stuff to make umount more reliable
+# todo: run this on a systemd timer on $primary, once per hour,
+# and if primary is, change that timer over to primary, and make
+# sure we mount the latest
+
+
+
 if $conf_only; then
     exit
 fi
@@ -135,7 +163,9 @@ fi
 if $dry_run; then
     btrbk -n $resume_arg run
 else
-    btrbk -q $resume_arg run
+    # -q and just using the syslog option seemed nice,
+    # but it doesn't show when a send has a parent and when it doesn't.
+    btrbk $resume_arg run
 fi
 
 # if we have /p, rsync to targets without /p
@@ -155,15 +185,7 @@ if mountpoint /p >/dev/null; then
 fi
 
 if ! $dry_run; then
-    for tg in ${targets[@]}; do
-        scp $script_dir/{mount-latest-subvol,check-subvol-stale} \
-            root@$tg:/usr/local/bin
-        ssh root@$tg bash <<'EOF'
-set -e
-chmod +x /usr/local/bin/{mount-latest-subvol,check-subvol-stale}
-mount-latest-subvol
-EOF
-    done
+    $script_dir/mount-latest-remote ${targets[@]}
 fi